## libheif 1.21.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.16.3) # Oldest Ubuntu LTS (20.04 currently)

project(libheif LANGUAGES C CXX VERSION 1.21.2)

# compatibility_version is never allowed to be decreased for any specific SONAME.
# Libtool in the libheif-1.15.1 release had set it to 17.0.0, so we have to use this for the v1.x.y versions.
# With v2.0.0, we can reset this to more closely follow the real version name, i.e. "2.0.0".
# CMake 3.17.0 added "MACHO_COMPATIBILITY_VERSION", but we are currently stuck at cmake 3.16.3.
set(MACOS_COMPATIBLE_VERSION "17.0.0")

# https://cmake.org/cmake/help/v3.1/policy/CMP0054.html
cmake_policy(VERSION 3.0...3.22)
include(GNUInstallDirs)

# The version number.
set (PACKAGE_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH})

# Check for header files.
include (${CMAKE_ROOT}/Modules/CheckIncludeFileCXX.cmake)

CHECK_INCLUDE_FILE_CXX(bit HAVE_BIT)
if (HAVE_BIT)
  add_definitions(-DHAVE_BIT)
endif()

CHECK_INCLUDE_FILE_CXX(unistd.h HAVE_UNISTD_H)
if (HAVE_UNISTD_H)
  add_definitions(-DHAVE_UNISTD_H)
endif()

if (APPLE)
  option(BUILD_FRAMEWORK "Build as Apple Frameworks" OFF)
endif()

if(NOT MSVC)
  # cmake 3.24 introduces this variable, but for backward compatibility, we set it explicitly
  if (CMAKE_COMPILE_WARNING_AS_ERROR)
      add_definitions(-Werror)
  endif ()

  add_definitions(-Wall)
  add_definitions(-Wsign-compare)
  add_definitions(-Wconversion)
  add_definitions(-Wno-sign-conversion)
  add_definitions(-Wno-error=conversion)
  add_definitions(-Wno-error=unused-parameter)
  add_definitions(-Wno-error=deprecated-declarations)
  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      add_definitions(-Wno-error=tautological-compare)
      add_definitions(-Wno-error=tautological-constant-out-of-range-compare)
  endif ()
endif()

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Create the compile command database for clang by default
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(BUILD_SHARED_LIBS "Build shared libraries" ON)

include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wno-error=potentially-evaluated-expression has_potentially_evaluated_expression)
if (has_potentially_evaluated_expression)
  add_definitions(-Wno-error=potentially-evaluated-expression)
endif()

LIST (APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules")

# TODO: when our minimum CMake reaches 3.20, replace this with "CMAKE_<LANG>_BYTE_ORDER"
include (TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
add_compile_definitions(IS_BIG_ENDIAN=${IS_BIG_ENDIAN})

# --- codec plugins

option(ENABLE_PLUGIN_LOADING "Support loading of plugins" ON)
set(PLUGIN_DIRECTORY "${CMAKE_INSTALL_FULL_LIBDIR}/libheif" CACHE STRING "Plugin directory")
set(PLUGIN_INSTALL_DIRECTORY "" CACHE STRING "Plugin install directory (leaving it empty will use PLUGIN_DIRECTORY)")

if (ENABLE_PLUGIN_LOADING)
    set(PLUGIN_LOADING_SUPPORTED_AND_ENABLED TRUE)

    if (PLUGIN_INSTALL_DIRECTORY STREQUAL "")
        set(COMPUTED_PLUGIN_INSTALL_DIRECTORY ${PLUGIN_DIRECTORY})
    else ()
        set(COMPUTED_PLUGIN_INSTALL_DIRECTORY ${PLUGIN_INSTALL_DIRECTORY})
    endif ()

    install(DIRECTORY DESTINATION ${COMPUTED_PLUGIN_INSTALL_DIRECTORY} DIRECTORY_PERMISSIONS
        OWNER_WRITE OWNER_READ OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE)
endif()

macro(plugin_option optionVariableName displayName defaultEnabled defaultPlugin)
    option(WITH_${optionVariableName} "Build ${displayName}" ${defaultEnabled})
    option(WITH_${optionVariableName}_PLUGIN "Build ${displayName} as a plugin" ${defaultPlugin})
endmacro()

macro(plugin_compilation_info optionVariableName detectionVariable displayName)
    if (${detectionVariable}_FOUND AND WITH_${optionVariableName}_PLUGIN AND PLUGIN_LOADING_SUPPORTED_AND_ENABLED)
        set(msg "+ separate plugin")
    elseif (${detectionVariable}_FOUND)
        set(msg "+ built-in")
    elseif (WITH_${optionVariableName})
        set(msg "- not found")
    else()
        set(msg "- disabled")
    endif ()

    string(LENGTH "${displayName}" len)
    math(EXPR fill "38 - ${len}")
    string(SUBSTRING "                                                   " 0 ${fill} filler)
    message("${displayName}${filler}: ${msg}")
    unset(msg)
endmacro()

# libde265

plugin_option(LIBDE265 "libde265 HEVC decoder" ON OFF)
if (WITH_LIBDE265)
    find_package(LIBDE265)
endif()

# x265

plugin_option(X265 "x265 HEVC encoder" ON OFF)
if (WITH_X265)
    find_package(X265)
endif()

# kvazaar

plugin_option(KVAZAAR "kvazaar HEVC encoder" OFF OFF)
if (WITH_KVAZAAR)
    find_package(kvazaar)
    if ("${HAVE_KVAZAAR_ENABLE_LOGGING}")
        add_definitions(-DHAVE_KVAZAAR_ENABLE_LOGGING=1)
    else ()
        add_definitions(-DHAVE_KVAZAAR_ENABLE_LOGGING=0)
    endif ()
endif ()

# uvg266

plugin_option(UVG266 "uvg266 VVC encoder" OFF OFF)
if (WITH_UVG266)
    find_package(UVG266)
    if ("${HAVE_UVG266_ENABLE_LOGGING}")
        add_definitions(-DHAVE_UVG266_ENABLE_LOGGING=1)
    else ()
        add_definitions(-DHAVE_UVG266_ENABLE_LOGGING=0)
    endif ()
endif ()

# vvdec

plugin_option(VVDEC "vvdec VVC decoder" OFF OFF)
if (WITH_VVDEC)
    # TODO: how to do configure vvdec cleanly?
    find_package(Threads REQUIRED)
    find_package(vvdec 3.0.0)
    if (vvdec_FOUND)
        set(vvdec_LIBRARIES vvdec::vvdec)
    endif()
endif ()

# vvenc

plugin_option(VVENC "vvenc VVC encoder" OFF OFF)
if (WITH_VVENC)
    # TODO: how to do configure vvenc cleanly?
    find_package(Threads REQUIRED)
    find_package(vvenc 1.12.0)
    if (vvenc_FOUND)
        set(vvenc_LIBRARIES vvenc::vvenc)
    endif()
endif ()

# x264

plugin_option(X264 "x264 AVC encoder" ON OFF)
if (WITH_X264)
    find_package(X264)
endif()

# openh264 decoder

plugin_option(OpenH264_DECODER "OpenH264 decoder" ON OFF)
# plugin_option(OpenH264_ENCODER "OpenH264 encoder" ON OFF)
if (WITH_OpenH264_ENCODER OR WITH_OpenH264_DECODER)
    find_package(OpenH264)

    # When decoding/encoding is disabled, overwrite the *_FOUND variables, because they are used to ultimately decide what to build.
    # TODO
    if (OpenH264_FOUND AND WITH_OpenH264_DECODER)
        set(OpenH264_DECODER_FOUND TRUE)
    endif()
#    if (OpenH264_FOUND AND WITH_OpenH264_ENCODER)
#        set(OpenH264_ENCODER_FOUND TRUE)
#    endif()
endif()



# dav1d

plugin_option(DAV1D "Dav1d AV1 decoder" OFF ON)
if (WITH_DAV1D)
    find_package(DAV1D)
endif()

# aom

plugin_option(AOM_DECODER "AOM AV1 decoder" ON OFF)
plugin_option(AOM_ENCODER "AOM AV1 encoder" ON OFF)
if (WITH_AOM_ENCODER OR WITH_AOM_DECODER)
    find_package(AOM)

    # When decoding/encoding is disabled, overwrite the *_FOUND variables, because they are used to ultimately decide what to build.
    if (NOT WITH_AOM_DECODER)
        set(AOM_DECODER_FOUND FALSE)
    endif()
    if (NOT WITH_AOM_ENCODER)
        set(AOM_ENCODER_FOUND FALSE)
    endif()
endif()

# svt

plugin_option(SvtEnc "SVT AV1 encoder" OFF ON)
if (WITH_SvtEnc)
    find_package(SvtEnc)
endif()

# rav1e

plugin_option(RAV1E "Rav1e AV1 encoder" OFF ON)
if (WITH_RAV1E)
    find_package(RAV1E)
endif()

# jpeg

plugin_option(JPEG_DECODER "JPEG decoder" OFF OFF)
plugin_option(JPEG_ENCODER "JPEG encoder" OFF OFF)
if (WITH_JPEG_ENCODER OR WITH_JPEG_DECODER)
    find_package(JPEG)
endif()

# openjpeg

plugin_option(OpenJPEG_ENCODER "OpenJPEG J2K encoder" OFF ON)
plugin_option(OpenJPEG_DECODER "OpenJPEG J2K decoder" OFF ON)
if (WITH_OpenJPEG_ENCODER OR WITH_OpenJPEG_DECODER)
    find_package(OpenJPEG 2)

    # Since the above does not work with Ubuntu 22.04 and Ubuntu 24.04, check again without version number
    if (NOT OpenJPEG_FOUND)
      find_package(OpenJPEG)

      if (OpenJPEG_FOUND AND NOT OPENJPEG_MAJOR_VERSION STREQUAL "2")
          message("OpenJPEG found, but we need version 2.x.x")
          set(OpenJPEG_FOUND FALSE)
      endif()
    endif()
endif()

# ffmpeg

plugin_option(FFMPEG_DECODER "FFMPEG HEVC decoder (HW accelerated)" OFF OFF)
if (WITH_FFMPEG_DECODER)
    find_package(FFMPEG COMPONENTS avcodec avutil)
endif ()

# openjph

plugin_option(OPENJPH_ENCODER "OpenJPH HT-J2K encoder" OFF ON)
# plugin_option(OPENJPH_DECODER "OpenJPH HT-J2K decoder" OFF ON)
if (WITH_OPENJPH_ENCODER OR WITH_OPENJPH_DECODER)
    find_package(OPENJPH)
endif()

# uncompressed

option(WITH_UNCOMPRESSED_CODEC " Support internal ISO/IEC 23001-17 uncompressed codec (experimental) " OFF)

# Web codecs

option(WITH_WEBCODECS "Support HEVC decoding through browser web codecs API (experimental)" OFF)

if (WITH_WEBCODECS)
   set(WEBCODECS_FOUND TRUE) # There is no library for web-codecs. Always mark as found.
endif()

# --- show codec compilation summary

message("\n=== Summary of compiled codecs ===")
plugin_compilation_info(LIBDE265 LIBDE265 "libde265 HEVC decoder")
plugin_compilation_info(FFMPEG_DECODER FFMPEG_avcodec "FFMPEG HEVC decoder (HW acc)")
plugin_compilation_info(WEBCODECS WEBCODECS "WebCodecs HEVC decoder (experimental)")
plugin_compilation_info(X265 X265 "x265 HEVC encoder")
plugin_compilation_info(KVAZAAR KVAZAAR "Kvazaar HEVC encoder")
plugin_compilation_info(AOM_DECODER AOM_DECODER "AOM AV1 decoder")
plugin_compilation_info(AOM_ENCODER AOM_ENCODER "AOM AV1 encoder")
plugin_compilation_info(DAV1D DAV1D "Dav1d AV1 decoder")
plugin_compilation_info(SvtEnc SvtEnc "SVT AV1 encoder")
plugin_compilation_info(RAV1E RAV1E "Rav1e AV1 encoder")
plugin_compilation_info(JPEG_DECODER JPEG "JPEG decoder")
plugin_compilation_info(JPEG_ENCODER JPEG "JPEG encoder")
plugin_compilation_info(X264 X264 "x264 AVC encoder")
plugin_compilation_info(OpenH264_DECODER OpenH264_DECODER "OpenH264 decoder")
# plugin_compilation_info(OpenH264_ENCODER OpenH264_ENCODER "OpenH264 encoder")
plugin_compilation_info(OpenJPEG_DECODER OpenJPEG "OpenJPEG J2K decoder")
plugin_compilation_info(OpenJPEG_ENCODER OpenJPEG "OpenJPEG J2K encoder")
# plugin_compilation_info(OPENJPH_DECODER OPENJPH "OpenJPH HT-J2K decoder")
plugin_compilation_info(OPENJPH_ENCODER OPENJPH "OpenJPH HT-J2K encoder")
plugin_compilation_info(UVG266_ENCODER UVG266 "uvg266 VVC encoder")
plugin_compilation_info(VVENC vvenc "vvenc VVC encoder")
plugin_compilation_info(VVDEC vvdec "vvdec VVC decoder")

# --- show summary which formats are supported

macro(format_compilation_info formatName decoding_supported encoding_supported)
    if (${decoding_supported})
        set(decoding "YES")
    else()
        set(decoding "NO ")
    endif()

    if (${encoding_supported})
        set(encoding "YES")
    else()
        set(encoding "NO ")
    endif()

    string(LENGTH "${formatName}" len)
    math(EXPR fill "12 - ${len}")
    string(SUBSTRING "                                        " 0 ${fill} filler)
    message("${formatName}${filler}    ${decoding}        ${encoding}")
    unset(msg)
endmacro()


if (LIBDE265_FOUND OR FFMPEG_avcodec_FOUND OR WITH_WEBCODECS)
    set(SUPPORTS_HEIC_DECODING TRUE)
endif()
if (X265_FOUND OR KVAZAAR_FOUND)
    set(SUPPORTS_HEIC_ENCODING TRUE)
endif()
if (AOM_DECODER_FOUND OR DAV1D_FOUND)
    set(SUPPORTS_AVIF_DECODING TRUE)
endif()
if (AOM_ENCODER_FOUND OR RAV1E_FOUND OR SvtEnc_FOUND)
    set(SUPPORTS_AVIF_ENCODING TRUE)
endif ()
if (JPEG_FOUND AND WITH_JPEG_DECODER)
    set(SUPPORTS_JPEG_DECODING TRUE)
endif()
if (JPEG_FOUND AND WITH_JPEG_ENCODER)
    set(SUPPORTS_JPEG_ENCODING TRUE)
endif()
if (OpenJPEG_FOUND AND WITH_OpenJPEG_DECODER)
    set(SUPPORTS_J2K_DECODING TRUE)
    set(SUPPORTS_J2K_HT_DECODING TRUE)
endif()
if (OpenJPEG_FOUND AND WITH_OpenJPEG_ENCODER)
    set(SUPPORTS_J2K_ENCODING TRUE)
endif()
if (OPENJPH_FOUND AND WITH_OPENJPH_ENCODER)
    set(SUPPORTS_J2K_HT_ENCODING TRUE)
endif()
if (OPENJPH_FOUND AND WITH_OPENJPH_DECODER)
    set(SUPPORTS_J2K_HT_ENCODING TRUE)
endif()
if (UVG266_FOUND OR vvenc_FOUND)
    set(SUPPORTS_VVC_ENCODING TRUE)
endif()
if (vvdec_FOUND AND WITH_VVDEC)
    set(SUPPORTS_VVC_DECODING TRUE)

=== examples/CMakeLists.txt ===
# Needed to find libheif/heif_version.h while compiling the library
include_directories(${libheif_BINARY_DIR} ${libheif_SOURCE_DIR}/libheif/api ${libheif_SOURCE_DIR}/libheif)

if (MSVC)
    set(getopt_sources
            ../extra/getopt.c
            ../extra/getopt.h
            ../extra/getopt_long.c
            )
    include_directories("../extra")
endif ()

add_executable(heif-info ${getopt_sources}
        heif_info.cc
        common.cc
        common.h)
target_link_libraries(heif-info heif)
install(TARGETS heif-info RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES heif-info.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)


add_executable(heif-dec ${getopt_sources}
        heif_dec.cc
        common.cc
        common.h)
target_link_libraries(heif-dec PRIVATE heif heifio)
target_include_directories(heif-dec PRIVATE ${libheif_SOURCE_DIR})
install(TARGETS heif-dec RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES heif-dec.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

# create symbolic link from the old name `heif-convert` to `heif-dec`
if(NOT WIN32)
  install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink heif-dec${CMAKE_EXECUTABLE_SUFFIX} \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/heif-convert${CMAKE_EXECUTABLE_SUFFIX})")
else()
  install(CODE "execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/heif-dec${CMAKE_EXECUTABLE_SUFFIX} ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR}/heif-convert${CMAKE_EXECUTABLE_SUFFIX})")
endif()


add_executable(heif-enc ${getopt_sources}
        heif_enc.cc
        benchmark.h
        benchmark.cc
        common.cc
        common.h
        SAI_datafile.cc
        SAI_datafile.h)
target_link_libraries(heif-enc PRIVATE heif heifio)
target_include_directories(heif-enc PRIVATE ${libheif_SOURCE_DIR})
install(TARGETS heif-enc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES heif-enc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

if (WITH_HEADER_COMPRESSION)
    target_compile_definitions(heif-enc PRIVATE WITH_HEADER_COMPRESSION=1)
endif ()


if (WITH_EXAMPLE_HEIF_THUMB AND PNG_FOUND)
    add_executable(heif-thumbnailer ${getopt_sources}
            heif_thumbnailer.cc
            common.cc
            common.h)
    target_link_libraries(heif-thumbnailer heif heifio)
    target_include_directories(heif-thumbnailer PRIVATE ${libheif_SOURCE_DIR})

    install(TARGETS heif-thumbnailer RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES heif-thumbnailer.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endif()



if (WITH_EXAMPLE_HEIF_VIEW)
    find_package(SDL2 NO_MODULE)

    if (SDL2_FOUND)
        add_executable(heif-view ${getopt_sources}
                heif_view.cc
                sdl.cc
                sdl.hh
                common.cc
                common.h)
        target_link_libraries(heif-view PRIVATE heif SDL2::SDL2main SDL2::SDL2)
        install(TARGETS heif-view RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    endif ()
endif ()


add_executable(heif-test ${getopt_sources}
        heif_test.cc
        common.cc
        common.h)
target_link_libraries(heif-test heif)

=== libheif/CMakeLists.txt ===
include(CMakePackageConfigHelpers)

configure_file(api/libheif/heif_version.h.in ${CMAKE_CURRENT_BINARY_DIR}/heif_version.h)

set(libheif_headers
        api/libheif/heif.h
        api/libheif/heif_library.h
        api/libheif/heif_image.h
        api/libheif/heif_color.h
        api/libheif/heif_error.h
        api/libheif/heif_plugin.h
        api/libheif/heif_properties.h
        api/libheif/heif_regions.h
        api/libheif/heif_items.h
        api/libheif/heif_sequences.h
        api/libheif/heif_tai_timestamps.h
        api/libheif/heif_brands.h
        api/libheif/heif_metadata.h
        api/libheif/heif_aux_images.h
        api/libheif/heif_entity_groups.h
        api/libheif/heif_security.h
        api/libheif/heif_encoding.h
        api/libheif/heif_decoding.h
        api/libheif/heif_image_handle.h
        api/libheif/heif_context.h
        api/libheif/heif_tiling.h
        api/libheif/heif_uncompressed.h
        api/libheif/heif_text.h
        api/libheif/heif_cxx.h
        ${CMAKE_CURRENT_BINARY_DIR}/heif_version.h)

set(libheif_sources
        bitstream.cc
        bitstream.h
        box.cc
        box.h
        error.cc
        error.h
        context.cc
        context.h
        file.cc
        file.h
        file_layout.h
        file_layout.cc
        pixelimage.cc
        pixelimage.h
        plugin_registry.cc
        nclx.cc
        nclx.h
        plugin_registry.h
        security_limits.cc
        security_limits.h
        init.cc
        init.h
        logging.h
        logging.cc
        compression.h
        compression_brotli.cc
        compression_zlib.cc
        common_utils.cc
        common_utils.h
        region.cc
        region.h
        brands.cc
        brands.h
        text.cc
        text.h
        api_structs.h
        api/libheif/heif.cc
        api/libheif/heif_library.cc
        api/libheif/heif_image.cc
        api/libheif/heif_color.cc
        api/libheif/heif_regions.cc
        api/libheif/heif_plugin.cc
        api/libheif/heif_properties.cc
        api/libheif/heif_items.cc
        api/libheif/heif_sequences.cc
        api/libheif/heif_tai_timestamps.cc
        api/libheif/heif_brands.cc
        api/libheif/heif_metadata.cc
        api/libheif/heif_aux_images.cc
        api/libheif/heif_entity_groups.cc
        api/libheif/heif_security.cc
        api/libheif/heif_encoding.cc
        api/libheif/heif_decoding.cc
        api/libheif/heif_image_handle.cc
        api/libheif/heif_context.cc
        api/libheif/heif_tiling.cc
        api/libheif/heif_uncompressed.cc
        api/libheif/heif_text.cc
        codecs/decoder.h
        codecs/decoder.cc
        codecs/encoder.h
        codecs/encoder.cc
        image-items/hevc.cc
        image-items/hevc.h
        codecs/hevc_boxes.cc
        codecs/hevc_boxes.h
        codecs/hevc_dec.cc
        codecs/hevc_dec.h
        codecs/hevc_enc.cc
        codecs/hevc_enc.h
        image-items/avif.cc
        image-items/avif.h
        codecs/avif_enc.cc
        codecs/avif_enc.h
        codecs/avif_dec.cc
        codecs/avif_dec.h
        codecs/avif_boxes.cc
        codecs/avif_boxes.h
        image-items/jpeg.h
        image-items/jpeg.cc
        codecs/jpeg_boxes.h
        codecs/jpeg_boxes.cc
        codecs/jpeg_dec.h
        codecs/jpeg_dec.cc
        codecs/jpeg_enc.h
        codecs/jpeg_enc.cc
        image-items/jpeg2000.h
        image-items/jpeg2000.cc
        codecs/jpeg2000_dec.h
        codecs/jpeg2000_dec.cc
        codecs/jpeg2000_enc.h
        codecs/jpeg2000_enc.cc
        codecs/jpeg2000_boxes.h
        codecs/jpeg2000_boxes.cc
        image-items/vvc.h
        image-items/vvc.cc
        codecs/vvc_dec.h
        codecs/vvc_dec.cc
        codecs/vvc_enc.h
        codecs/vvc_enc.cc
        codecs/vvc_boxes.h
        codecs/vvc_boxes.cc
        image-items/avc.h
        image-items/avc.cc
        codecs/avc_boxes.h
        codecs/avc_boxes.cc
        codecs/avc_dec.h
        codecs/avc_dec.cc
        codecs/avc_enc.h
        codecs/avc_enc.cc
        image-items/mask_image.h
        image-items/mask_image.cc
        image-items/image_item.h
        image-items/image_item.cc
        image-items/grid.h
        image-items/grid.cc
        image-items/overlay.h
        image-items/overlay.cc
        image-items/iden.h
        image-items/iden.cc
        image-items/tiled.h
        image-items/tiled.cc
        color-conversion/colorconversion.cc
        color-conversion/colorconversion.h
        color-conversion/rgb2yuv.cc
        color-conversion/rgb2yuv.h
        color-conversion/rgb2yuv_sharp.cc
        color-conversion/rgb2yuv_sharp.h
        color-conversion/yuv2rgb.cc
        color-conversion/yuv2rgb.h
        color-conversion/rgb2rgb.cc
        color-conversion/rgb2rgb.h
        color-conversion/monochrome.cc
        color-conversion/monochrome.h
        color-conversion/hdr_sdr.cc
        color-conversion/hdr_sdr.h
        color-conversion/alpha.cc
        color-conversion/alpha.h
        color-conversion/chroma_sampling.cc
        color-conversion/chroma_sampling.h
        sequences/seq_boxes.h
        sequences/seq_boxes.cc
        sequences/chunk.h
        sequences/chunk.cc
        sequences/track.h
        sequences/track.cc
        sequences/track_visual.h
        sequences/track_visual.cc
        sequences/track_metadata.h
        sequences/track_metadata.cc
        ${libheif_headers})

add_library(heif ${libheif_sources})

if (ENABLE_PLUGIN_LOADING)
    if (WIN32)
        target_sources(heif PRIVATE plugins_windows.cc plugins_windows.h)
    else ()
        target_sources(heif PRIVATE plugins_unix.cc plugins_unix.h)
    endif ()
endif ()

option(ENABLE_EXPERIMENTAL_FEATURES "Compile experimental features and install headers with unstable API" OFF)
if (ENABLE_EXPERIMENTAL_FEATURES)
    target_sources(heif PRIVATE api/libheif/heif_experimental.h api/libheif/heif_experimental.cc)

    list(APPEND libheif_headers api/libheif/heif_experimental.h)

    target_compile_definitions(heif PUBLIC HEIF_ENABLE_EXPERIMENTAL_FEATURES)
endif()

# Needed to find libheif/heif_version.h while compiling the library
target_include_directories(heif PRIVATE ${libheif_BINARY_DIR} ${libheif_SOURCE_DIR}/libheif ${libheif_SOURCE_DIR}/libheif/api)

# Propagate include/libheif to consume the headers from other projects
target_include_directories(heif
        PUBLIC
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/${PROJECT_NAME}>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>)

set_target_properties(heif
        PROPERTIES
        VERSION ${PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR})

if (APPLE)
    set_target_properties(heif PROPERTIES
	    LINK_FLAGS "-Wl,-compatibility_version,${MACOS_COMPATIBLE_VERSION}")
endif ()

if (BUILD_FRAMEWORK) 
  set_target_properties(heif PROPERTIES
    FRAMEWORK TRUE
    FRAMEWORK_VERSION "${PACKAGE_VERSION}"
    PRODUCT_BUNDLE_IDENTIFIER "github.com/strukturag/libheif"
    XCODE_ATTRIBUTE_INSTALL_PATH "@rpath"
    # OUTPUT_NAME "heif"
    XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ""
    XCODE_ATTRIBUTE_CODE_SIGNING_ALLOWED "NO"
    XCODE_ATTRIBUTE_CODE_SIGNING_REQUIRED "NO"
    PUBLIC_HEADER "${libheif_headers}"
    MACOSX_FRAMEWORK_IDENTIFIER "github.com/strukturag/libheif"
    MACOSX_FRAMEWORK_BUNDLE_VERSION "${PACKAGE_VERSION}"
    MACOSX_FRAMEWORK_SHORT_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
    MACOSX_RPATH TRUE)
endif()

target_compile_definitions(heif
        PUBLIC
        LIBHEIF_EXPORTS
        HAVE_VISIBILITY)

if (PLUGIN_LOADING_SUPPORTED_AND_ENABLED)
    target_compile_definitions(heif PRIVATE ENABLE_PLUGIN_LOADING=1)
    target_link_libraries(heif PRIVATE ${CMAKE_DL_LIBS})
endif ()

add_subdirectory(plugins)

if (LIBSHARPYUV_FOUND)
    message("Compiling in 'libsharpyuv'")
    target_compile_definitions(heif PUBLIC HAVE_LIBSHARPYUV=1)
    target_include_directories(heif PRIVATE ${LIBSHARPYUV_INCLUDE_DIRS})
    target_link_libraries(heif PRIVATE ${LIBSHARPYUV_LIBRARIES})
else ()
    message("Not compiling 'libsharpyuv'")
endif ()

if (ZLIB_FOUND)
    target_compile_definitions(heif PRIVATE HAVE_ZLIB=1)
    target_link_libraries(heif PRIVATE ZLIB::ZLIB)
endif ()

if (Brotli_FOUND)
    target_compile_definitions(heif PUBLIC HAVE_BROTLI=1)
    target_include_directories(heif PRIVATE ${BROTLI_INCLUDE_DIRS})
    target_link_libraries(heif PRIVATE ${BROTLI_LIBS})
endif()

if (ENABLE_MULTITHREADING_SUPPORT)
    find_package(Threads)
    target_link_libraries(heif PRIVATE ${CMAKE_THREAD_LIBS_INIT})

    target_compile_definitions(heif PRIVATE ENABLE_MULTITHREADING_SUPPORT=1)
    if (ENABLE_PARALLEL_TILE_DECODING)
        target_compile_definitions(heif PRIVATE ENABLE_PARALLEL_TILE_DECODING=1)
    endif ()
endif ()

if (WITH_UNCOMPRESSED_CODEC)
    target_compile_definitions(heif PUBLIC WITH_UNCOMPRESSED_CODEC=1)
    target_sources(heif PRIVATE
            codecs/uncompressed/unc_boxes.h
            codecs/uncompressed/unc_boxes.cc
            image-items/unc_image.h
            image-items/unc_image.cc
            codecs/uncompressed/unc_codec.h
            codecs/uncompressed/unc_codec.cc
            codecs/uncompressed/unc_dec.h
            codecs/uncompressed/unc_dec.cc
            codecs/uncompressed/unc_enc.h
            codecs/uncompressed/unc_enc.cc
            codecs/uncompressed/decoder_abstract.h
            codecs/uncompressed/decoder_abstract.cc
            codecs/uncompressed/decoder_component_interleave.h
            codecs/uncompressed/decoder_component_interleave.cc
            codecs/uncompressed/decoder_pixel_interleave.h
            codecs/uncompressed/decoder_pixel_interleave.cc
            codecs/uncompressed/decoder_mixed_interleave.h
            codecs/uncompressed/decoder_mixed_interleave.cc
            codecs/uncompressed/decoder_row_interleave.h
            codecs/uncompressed/decoder_row_interleave.cc
            codecs/uncompressed/decoder_tile_component_interleave.h
            codecs/uncompressed/decoder_tile_component_interleave.cc)
endif ()

if (ENABLE_EXPERIMENTAL_MINI_FORMAT)
    target_compile_definitions(heif PUBLIC ENABLE_EXPERIMENTAL_MINI_FORMAT=1)
    target_sources(heif PRIVATE
            mini.h
            mini.cc)
endif ()

write_basic_package_version_file(${PROJECT_NAME}-config-version.cmake COMPATIBILITY ExactVersion)

install(TARGETS heif EXPORT ${PROJECT_NAME}-config
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        FRAMEWORK DESTINATION Library/Frameworks COMPONENT runtime OPTIONAL
        )

install(FILES ${libheif_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

install(EXPORT ${PROJECT_NAME}-config DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake DESTINATION
        "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")


# --- on Windows, copy the DLL into the executable directory for easier development

if (WIN32 AND BUILD_SHARED_LIBS)
    add_custom_command(TARGET heif POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE:heif>
            $<TARGET_FILE_DIR:heif>/../examples
    )
endif ()

=== tests/CMakeLists.txt ===
# Needed to find libheif/heif_version.h while compiling the library
include_directories(${libheif_BINARY_DIR} ${libheif_SOURCE_DIR}/libheif ${libheif_SOURCE_DIR}/libheif/api)

# prepare C++ configuration file (test-config.cc)

set(TESTING_DATA_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/data")
set(LIBHEIFIO_TESTING_DATA_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/data/heifio")
configure_file(test-config.cc.in ${CMAKE_BINARY_DIR}/generated/test-config.cc)

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set_source_files_properties(catch_amalgamated.cpp PROPERTIES COMPILE_FLAGS -Wno-conversion)
endif()

add_library(testframework STATIC ${CMAKE_BINARY_DIR}/generated/test-config.cc test_utils.cc catch_amalgamated.cpp)
target_link_libraries(testframework PRIVATE heif)

macro(add_libheif_test TEST_FILE)
    set(TEST_NAME ${TEST_FILE})
    add_executable(${TEST_NAME} ${TEST_FILE}.cc)
    target_link_libraries(${TEST_NAME} PRIVATE heif testframework)
    add_test(NAME ${TEST_NAME} COMMAND ./${TEST_NAME})
    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_REGULAR_EXPRESSION "[1-9][0-9]* skipped")
endmacro()

macro(add_heifio_test TEST_FILE)
    set(TEST_NAME ${TEST_FILE})
    add_executable(${TEST_NAME} main.cc ${TEST_FILE}.cc)
    target_link_libraries(${TEST_NAME} PRIVATE heif heifio testframework)
    target_include_directories(${TEST_NAME} PRIVATE ${libheif_SOURCE_DIR})
    add_test(NAME ${TEST_NAME} COMMAND ./${TEST_NAME})
    set_tests_properties(${TEST_NAME} PROPERTIES SKIP_REGULAR_EXPRESSION "[1-9][0-9]* skipped")
endmacro()

# --- tests that require access to internal symbols

if (WITH_REDUCED_VISIBILITY)
    message(WARNING "Several unit tests have been disabled because they can only be compiled with full symbol visibility (WITH_REDUCED_VISIBILITY=OFF)")
else()
    add_libheif_test(bitstream_tests)
    add_libheif_test(box_equals)
    add_libheif_test(conversion)
    add_libheif_test(idat)
    add_libheif_test(jpeg2000)
    add_libheif_test(avc_box)
    add_libheif_test(file_layout)
endif()

if (ENABLE_EXPERIMENTAL_FEATURES AND NOT WITH_REDUCED_VISIBILITY)
    add_libheif_test(pixel_data_types)
endif()

if (NOT WITH_REDUCED_VISIBILITY AND WITH_UNCOMPRESSED_CODEC)
    add_libheif_test(uncompressed_box)
endif()

# --- tests that only access the public API

add_libheif_test(encode)
add_libheif_test(extended_type)
add_libheif_test(region)
add_libheif_test(tai)
add_libheif_test(text)
add_libheif_test(cxx_wrapper)

if (WITH_OPENJPH_ENCODER AND SUPPORTS_J2K_HT_ENCODING)
    add_libheif_test(encode_htj2k)
else()
    message(INFO "Disabling HT-JPEG 2000 encoder tests because no HT-JPEG 2000 codec is enabled")
endif()

if (WITH_OpenJPEG_ENCODER AND SUPPORTS_J2K_ENCODING)
    add_libheif_test(encode_jpeg2000)
else()
    message(INFO "Disabling JPEG 2000 encoder tests because no JPEG 2000 codec is enabled")
endif()

if (ENABLE_EXPERIMENTAL_MINI_FORMAT)
    if (NOT WITH_REDUCED_VISIBILITY)
        add_libheif_test(mini_box)
    endif()
    add_libheif_test(mini_decode)
endif()

if (WITH_UNCOMPRESSED_CODEC)
    add_libheif_test(uncompressed_decode)
    add_libheif_test(uncompressed_decode_mono)
    add_libheif_test(uncompressed_decode_rgb)
    add_libheif_test(uncompressed_decode_rgb16)
    add_libheif_test(uncompressed_decode_rgb565)
    add_libheif_test(uncompressed_decode_rgb7)
    add_libheif_test(uncompressed_decode_ycbcr)
    add_libheif_test(uncompressed_decode_ycbcr420)
    add_libheif_test(uncompressed_decode_ycbcr422)
    add_libheif_test(uncompressed_encode)

    if (ZLIB_FOUND)
        add_libheif_test(uncompressed_decode_generic_compression)
    else()
        message(WARNING "Generic compress tests of the 'uncompressed codec' are not compiled because zlib was not found")
    endif ()
else()
    message(WARNING "Tests of the 'uncompressed codec' are not compiled because the uncompressed codec is not enabled (WITH_UNCOMPRESSED_CODEC==OFF)")
endif ()

add_heifio_test(tiffdecode)

if (ENABLE_PLUGIN_LOADING)
    get_directory_property(ALL_TESTS TESTS)
    set_tests_properties(${ALL_TESTS} PROPERTIES ENVIRONMENT "LIBHEIF_PLUGIN_PATH=${CMAKE_BINARY_DIR}/libheif/plugins")
endif ()

=== debian/changelog ===
libheif (1.21.2-3) unstable; urgency=medium

  * Team upload
  * Have libheif-dev depend on libbrotli-dev as required by the
    pkgconfig file.
  * Demote libheif-plugin-libde265 from Depends to Suggests on Ubuntu
    to avoid possible patent concerns.
  * d/rules: Fix substvar assignment syntax for libheif:Suggests and
    libheif:Recommends (colon was used instead of equals sign, causing
    the variables to expand to empty strings)

 -- Charles <charles05@canonical.com>  Sat, 21 Feb 2026 14:12:49 -0000

libheif (1.21.2-2) unstable; urgency=medium

  * Team upload
  * Don't build kvazaar plugin on loong64 because kvazaar FTBFS there

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 07 Feb 2026 11:24:57 -0500

libheif (1.21.2-1) unstable; urgency=medium

  * New upstream version 1.21.2
    - Fixes CVE-2025-68431 (Closes: #1124317).
  * Remove patches applied upstream.
  * Update symbols for new upstream version.
  * d/control: Update build dependencies for cmake AOM detection.
  * d/control: Update Standards-Version to 4.7.3 and remove optional priority.

 -- Joachim Bauch <fancycode@debian.org>  Mon, 19 Jan 2026 16:27:41 +0100

=== debian/control ===
Source: libheif
Section: libs
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Joachim Bauch <fancycode@debian.org>
Build-Depends:
 aom-tools,
 cmake,
 debhelper-compat (= 13),
 libaom-dev,
 libavcodec-dev,
 libdav1d-dev,
 libbrotli-dev,
 libde265-dev (>= 1.0.7),
 libgdk-pixbuf-2.0-dev,
 libjpeg-dev,
 libkvazaar-dev [!loong64],
 libopenjp2-7-dev,
 libpng-dev,
# librav1e-dev is built by src:rust-rav1e which is not available on all platforms.
# Make sure to use the same list in the "libheif-plugin-rav1e" package below.
 librav1e-dev [amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x],
 libsdl2-dev,
 libsharpyuv-dev,
 libsvtav1enc-dev,
 libwebm-dev,
 libx265-dev,
 libyuv-dev,
 libz-dev,
 pkgconf
Standards-Version: 4.7.3
Homepage: http://www.libheif.org
Vcs-Git: https://salsa.debian.org/multimedia-team/libheif.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libheif

Package: libheif1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${libheif:Depends}
Recommends:
 ${libheif:Recommends},
 libheif-plugin-aomenc (= ${binary:Version})
Suggests:
 ${libheif:Suggests},
 libheif-plugin-ffmpegdec (= ${binary:Version}),
 libheif-plugin-jpegdec (= ${binary:Version}),
 libheif-plugin-jpegenc (= ${binary:Version}),
 libheif-plugin-j2kdec (= ${binary:Version}),
 libheif-plugin-j2kenc (= ${binary:Version}),
 libheif-plugin-kvazaar (= ${binary:Version}) [!loong64],
 libheif-plugin-rav1e (= ${binary:Version}) [amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x],
 libheif-plugin-svtenc (= ${binary:Version})
Description: HEIF and AVIF file format decoder and encoder - shared library
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the shared library.

Package: libheif-plugin-aomdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - aomdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the aomdec plugin that uses libaom to decode AV1 images.
 .
 libaom: https://aomedia.org/

Package: libheif-plugin-aomenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - aomenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the aomenc plugin that uses libaom to encode AV1 images.
 .
 libaom: https://aomedia.org/

Package: libheif-plugin-dav1d
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - dav1d plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the dav1d plugin that uses dav1d to decode AV1 images.
 .
 dav1d: https://www.videolan.org/projects/dav1d.html

Package: libheif-plugin-ffmpegdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - ffmpegdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the ffmpegdec plugin that uses FFmpeg to decode HEVC
 images. It can make use of H265 hardware decoders if available in FFmpeg.
 .
 FFmpeg: https://www.ffmpeg.org/

Package: libheif-plugin-j2kdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - j2kdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the j2kdec plugin that uses OpenJPEG to decode JPEG2000
 images.
 .
 OpenJPEG: https://www.openjpeg.org/

Package: libheif-plugin-j2kenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - j2kenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the j2kenc plugin that uses OpenJPEG to encode JPEG2000
 images.
 .
 OpenJPEG: https://www.openjpeg.org/

Package: libheif-plugin-jpegdec
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - jpegdec plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the jpegdec plugin that uses libjpeg to decode JPEG
 images.
 .
 libjpeg: https://www.libjpeg-turbo.org/

Package: libheif-plugin-jpegenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - jpegenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the jpegenc plugin that uses libjpeg to encode JPEG
 images.
 .
 libjpeg: https://www.libjpeg-turbo.org/

Package: libheif-plugin-kvazaar
Architecture: amd64 arm64 armhf i386 ppc64el riscv64 s390x alpha hppa hurd-i386 hurd-amd64 m68k powerpc ppc64 sh4 sparc64 x32
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - kvazaar plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the kvazaar plugin that uses kvazaar to encode HEVC
 images.
 .
 kvazaar: https://ultravideo.fi/kvazaar.html

Package: libheif-plugin-libde265
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - libde265 plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the libde265 plugin that uses libde265 to decode HEVC
 images.
 .
 libde265: https://www.libde265.org/

Package: libheif-plugin-rav1e
Architecture: amd64 arm64 armel armhf mips64el mipsel powerpc ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - rav1e plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the rav1e plugin that uses rav1e to encode AV1 images.
 .
 rav1e: https://github.com/xiph/rav1e

Package: libheif-plugin-svtenc
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: HEIF and AVIF file format decoder and encoder - svtenc plugin
 libheif is an ISO/IEC 23008-12:2017 HEIF and AVIF (AV1 Image File Format) file
 format decoder and encoder. There is partial support for ISO/IEC 23008-12:2022
 (2nd Edition) capabilities.
 .
 HEIF and AVIF are new image file formats employing HEVC (H.265) or AV1 image
 coding, respectively, for the best compression ratios currently possible.
 .
 libheif supports various codecs provided by plugins for image decoding and
 encoding.
 .
 This package contains the svtenc plugin that uses SVT-AV1 to encode AV1 images.
 .
 SVT-AV1: https://gitlab.com/AOMediaCodec/SVT-AV1

Package: libheif-plugin-x265
Architecture: any
Multi-Arch: same
Depends:
 libheif1 (= ${binary:Version}),
 ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk

PKD = $(abspath $(dir $(MAKEFILE_LIST)))
PKG = $(DEB_SOURCE)
VER = $(DEB_VERSION_UPSTREAM)
COMMIT = $$(git log -1 --pretty=%h)
LAST_TAG=$$(git describe --tags --abbrev=0)
COUNT_SINCE_LAST_TAG=$$(git rev-list $(LAST_TAG).. --count)
BASENAME=$(PKG)_$(VER)+$(COUNT_SINCE_LAST_TAG)+git$(COMMIT)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

rav1e_archs = $(shell sed -n 's/.*\blibrav1e-dev[[:space:]]*\[\(.*\)\].*/\1/p' debian/control)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DCMAKE_INSTALL_INCLUDEDIR=include/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
		-DPLUGIN_DIRECTORY=/usr/lib/$(DEB_HOST_MULTIARCH)/libheif/plugins \
		-DCMAKE_COMPILE_WARNING_AS_ERROR=OFF \
		-DWITH_AOM_DECODER_PLUGIN=ON \
		-DWITH_AOM_ENCODER_PLUGIN=ON \
		-DWITH_DAV1D=ON \
		-DWITH_DAV1D_PLUGIN=ON \
		-DWITH_HEADER_COMPRESSION=ON \
		-DWITH_FFMPEG_DECODER=ON \
		-DWITH_FFMPEG_DECODER_PLUGIN=ON \
		-DWITH_JPEG_DECODER=ON \
		-DWITH_JPEG_DECODER_PLUGIN=ON \
		-DWITH_JPEG_ENCODER=ON \
		-DWITH_JPEG_ENCODER_PLUGIN=ON \
		-DWITH_KVAZAAR=$(if $(filter loong64,$(DEB_HOST_ARCH)),OFF,ON) \
		-DWITH_KVAZAAR_PLUGIN=$(if $(filter loong64,$(DEB_HOST_ARCH)),OFF,ON) \
		-DWITH_LIBDE265_PLUGIN=ON \
		-DWITH_LIBSHARPYUV=ON \
		-DWITH_OpenJPEG_DECODER=ON \
		-DWITH_OpenJPEG_DECODER_PLUGIN=ON \
		-DWITH_OpenJPEG_ENCODER=ON \
		-DWITH_OpenJPEG_ENCODER_PLUGIN=ON \
		-DWITH_X265_PLUGIN=ON \
		-DWITH_RAV1E=$(if $(filter $(DEB_HOST_ARCH),$(rav1e_archs)),ON,OFF) \
		-DWITH_RAV1E_PLUGIN=$(if $(filter $(DEB_HOST_ARCH),$(rav1e_archs)),ON,OFF) \
		-DWITH_SvtEnc=ON \
		-DWITH_SvtEnc_PLUGIN=ON \
		-DWITH_UNCOMPRESSED_CODEC=ON

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LIBHEIF_PLUGIN_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/libheif/plugins ./debian/tests/test-decode
	LIBHEIF_PLUGIN_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/libheif/plugins dh_auto_test
endif

# some dependencies are in Ubuntu "universe"
# https://launchpad.net/bugs/2004453 https://launchpad.net/bugs/2004446
override_dh_gencontrol:
ifeq ($(shell dpkg-vendor --query vendor),Ubuntu)
	dh_gencontrol -- \
		-Vlibheif:Depends='libheif-plugin-aomdec (= $${binary:Version}) | libheif-plugin-dav1d (= $${binary:Version})' \
		-Vlibheif:Suggests='libheif-plugin-libde265 (= $${binary:Version}), libheif-plugin-x265 (= $${binary:Version})'
else
	dh_gencontrol -- \
		-Vlibheif:Depends='libheif-plugin-libde265 (= $${binary:Version}), libheif-plugin-dav1d (= $${binary:Version}) | libheif-plugin-aomdec (= $${binary:Version})' \
		-Vlibheif:Recommends='libheif-plugin-x265 (= $${binary:Version})'
endif

UURL = git://github.com/strukturag/libheif.git
get-head-source:
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting.))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
		|| $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	&& echo "# Checking out commit $(COMMIT)..." \
	&& git checkout -q $(COMMIT) \
	&& echo "# Setting times..." \
	&& git ls-tree -r --name-only HEAD | while read F ; do touch --no-dereference -d "@$$(git log -1 --format="%ct" -- "$$F")" "$$F"; done \
	&& echo "# Writing to $(BASENAME).orig.tar.xz..." \
	&& find -L . -xdev -type f -not -path "*/.git/*" -print | LC_ALL=C sort \
		| XZ_OPT="-6v" tar -caf "../$(BASENAME).orig.tar.xz" -T- --transform "s/^\./$(BASENAME)/g" --owner=root --group=root --mode=a+rX
	@echo "# Cleaning up..." \
	&& $(RM) -r "$(PKG)-$(VER)"
